package trz.gaia;

import java.awt.*;
import java.awt.event.*;

class CellulaView extends Label implements MouseListener {

  Cellula model = null;
  Font font = new Font("Arial", Font.PLAIN, 12);

  public CellulaView(Cellula cellula) {

    this.model = cellula;
    addMouseListener(this);
    update();
  }

  public void update() {
    
    setFont(font);
    setText(model.toString());

    if (!model.isAttiva()) {
      setBackground(Color.white);
      return;
    }
    if (model.listaCon.size() == Cellula.EMBRIONE) {
      setBackground(Color.lightGray);
      return;
    }
    if (model.listaCon.size() <= Cellula.FORTEMENTE_INSTABILE) {
      setBackground(Color.red);
      return;
    }
    if (model.listaCon.size() <= Cellula.INSTABILE) {
      setBackground(Color.yellow);
      return;
    }
    if (model.listaCon.size() == Cellula.STABILE) {
      setBackground(Color.green);
      return;
    }
  }

  public void mouseClicked(MouseEvent e) { 
  
    //mettere un pop-up
  }

  public void mouseEntered(MouseEvent e) {
    
    //TEMPORANEO (funza solo se tutto e' fermo)
    Graphics g = model.net.view.main.getGraphics(); 
    
    //pulisco
    g.setColor(Color.white);
    g.clearRect(0, 0, model.net.view.main.getSize().width, model.net.view.main.getSize().height);

    Cellula tmp = null;
    g.setColor(Color.black);
    for (int i = 0; i < model.listaCell.size(); i++) {
      
      tmp = (Cellula)model.listaCell.elementAt(i); 
      //tmp.view.font = new Font("Arial", Font.BOLD, 14);
      g.drawLine( getLocation().x + getSize().width/2, getLocation().y + getSize().height/2, 
                  tmp.view.getLocation().x + tmp.view.getSize().width/2, 
                  tmp.view.getLocation().y + tmp.view.getSize().height/2);
      //tmp.view.update();
    }
    model.net.view.repaint(); 
    model.net.setText(model.dump());
  }

  public void mouseExited(MouseEvent e) {} 
  public void mousePressed(MouseEvent e){} 
  public void mouseReleased(MouseEvent e){} 

} //fine CellulaView

