package trz.gaia;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class Gaia extends Frame {

  Button start = new Button("Start");
  Button test = new Button("Test");
  Internet net = null;

  static SearchGraph graph = new SearchGraph("Gaia");
  
  public static void main(String[] args) {

    //impostazioni delle singole cellule
    Cellula.setN(3);
    Cellula.setStabilita(0.9991F);  //1 non cade mai
    Cellula.setRinascita(0.9910F);  //1 non entra mai in gaia
    Cellula.setVelocita(50);
    Cellula.setTempoPing(1500);
    Cellula.showCon = true;

    Gaia gaia = new Gaia(10);

    System.out.println(Cellula.N);
  }
    
  public Gaia(int dimensione) {
  
    net = new Internet(dimensione);
    System.out.println(net);
    System.out.println(net.getStatus());

    for (int i = 0; i < net.cellule.length; i++)
      net.cellule[i].start();
  
    setLayout(new FlowLayout());

    add(start);
    add(test);
    start.addActionListener(new GaiaListener());
    test.addActionListener(new GaiaListener());
    setSize(100, 100);
    setLocation(500, 400);
    show();
  }

  public void test() {

    net.view.status.setText("");  
    System.out.println("Inizio test");
    net.view.status.append("Inizio test\n");

    Enumeration e = graph.elements();
    SearchNode inizio = null;
    while (e.hasMoreElements()) {
    
      inizio = (SearchNode)e.nextElement();
      if (inizio.attivo)
        break;
    }
    
    Vector mancanti = new Vector();
    while (e.hasMoreElements()) 
      mancanti.addElement(e.nextElement()); 

    //System.out.println("Inizio " + mancanti);

    SearchNode goal = null;
    while(mancanti.size() > 0) {
                
      goal = (SearchNode)mancanti.elementAt(0);
      if (!goal.attivo) {
        mancanti.removeElementAt(0);
        continue;
      }
      SearchNode tmp = graph.depthFirstSearch(inizio, goal.state, mancanti);
      if (tmp == null) {
        System.out.println("####### Impossibile raggiungere " + goal.state + "#######");
        net.view.status.append("####### Impossibile raggiungere " + goal.state + "#######\n");
      }
      //mancanti.removeElementAt(0);
      graph.reset();

      //System.out.println(mancanti);
    }
    System.out.println("Fine test");
    net.view.status.append("Fine test\n");
  }

  class GaiaListener implements ActionListener {

    public void actionPerformed(ActionEvent event) {

      if(event.getActionCommand().equals("Stop")) {
      
        net.suspend();
        start.setLabel("Start");
      }
      else if (event.getActionCommand().equals("Start")) {
        net.resume();
        start.setLabel("Stop");
      }
      else if (event.getActionCommand().equals("Test")) {
        
        net.suspend();
        start.setLabel("Start");
        try {Thread.sleep(200);}catch(Exception e){}
        test();
      }
    }  
  }   //fine gaia listener
}
