package trz.gaia;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

class InternetView extends Frame {

  Panel main = new Panel();
  Internet net = null;
  TextArea status = new TextArea(6, 10);
  CellulaMoveListener listener = new CellulaMoveListener();

  public InternetView(Internet net) {

    this.net = net;
    setSize(600, 400);
    setLayout(new BorderLayout());
    status.setEditable(false);
    add(status, BorderLayout.SOUTH); 
    main.setLayout(new FlowLayout());
    add(main, BorderLayout.CENTER);

    main.addMouseListener(listener);
  } 

  public void addCellula(Component view) {

    view.setSize(30, 30);
    view.addMouseListener(listener);
    view.addMouseMotionListener(listener);
    main.add(view);
  }    
  
  public void setText(String s) {

    status.setText(s);
  }

  public void disegnaConnessioni() {

      
      Vector listaCon = net.getConnessioni();

      Graphics g = main.getGraphics();
      g.setColor(Color.white);
      g.clearRect(0, 0, main.getSize().width, main.getSize().height);

      g.setColor(Color.black);


      Connessione tmp = null;
      Cellula from = null;
      Cellula to = null;
      for (int i = 0; i < listaCon.size(); i++) {
      
        tmp = (Connessione)listaCon.elementAt(i); 
        from = tmp.from;
        to = tmp.to;
        //tmp.view.font = new Font("Arial", Font.BOLD, 14);
        g.drawLine( from.view.getLocation().x + from.view.getSize().width/2, 
                    from.view.getLocation().y + from.view.getSize().height/2, 
                    to.view.getLocation().x + to.view.getSize().width/2, 
                    to.view.getLocation().y + to.view.getSize().height/2);
        //tmp.view.update();
      }
  }

  //boolean showCon = false;
  class CellulaMoveListener implements MouseListener, MouseMotionListener {

    Component selected = null;
    //do per socntato che venga draggata sempre una cellula per volta
    int x = 0;
    int y = 0;
    
    public void mouseClicked(MouseEvent e) {
      

      if (e.getClickCount() != 2)
        return;
      disegnaConnessioni();
    }                

    public void mouseEntered(MouseEvent e) {}

    public void mouseExited(MouseEvent e) {} 
    
    public void mousePressed(MouseEvent e){

//      System.out.println(e + " - " + e.getSource() + " - " + selected);
      
/*
      selected = null;
      if (e.getSource() instanceof CellulaView)
        selected = (Component)e.getSource();
*/
		//setto x e y sulla posizione dell' ultimo evento
		//rispetto alla finestra padre
			if (e.getSource() instanceof CellulaView) {
    		selected = (Component)e.getSource();

				Point p = selected.getLocation();
				x = p.x+e.getX();
				y = p.y+e.getY();
    	}
    } 
  
    public void mouseReleased(MouseEvent e){
      
      //System.out.println(e + " - " + e.getSource() + " - " + selected);

/*
      if (e.getSource() instanceof Panel && selected != null) {
        selected.setLocation(e.getX(), e.getY());
        ((CellulaView)selected).update();   //non so perche' ma senza di questo 
                                            //a volte non lo ridisegna :(
      }
*/
      disegnaConnessioni();
    } 

		public void mouseDragged(java.awt.event.MouseEvent e) {
		
			//if (e.getSource() instanceof CellulaView) {
			
    		selected = (Component)e.getSource();

				Point p = selected.getLocation();
				int dx = x - (p.x+e.getX());
				int dy = y - (p.y+e.getY());

				selected.setLocation(p.x-dx, p.y-dy);

				//setto ancora x e y sulla posizione dell' ultimo evento
				//rispetto alla finestra padre
				x = p.x+e.getX();
				y = p.y+e.getY();
			//}
		}
    
		public void mouseMoved(java.awt.event.MouseEvent e) {}
	} 

} //fine view  