package trz.gaia;

import java.util.*;

class Internet {

  int max = 5;
  Cellula[] cellule = null;

  InternetView view = new InternetView(this);

  //da 0 a 1 (1 = nessuno attivo, 0 = tutti attivi)
  public Internet(int dimensione) {

    //al momento non esistono ip non utilizzati da nessuna macchina

    max = dimensione;
    cellule = new Cellula[max];
    for (int i = 0; i < max; i++) {
      cellule[i] = new Cellula("C" + i, i, this);
      view.addCellula(cellule[i].view);
    }
    view.show();
  }
  
  public void setText(String s) {

    view.setText(s);  
  } 

  public Cellula contatta(int ip) {

    return cellule[ip];
  }
  
  public String getStatus() {
    
    return  "-";  //calcolare attive e contente o altro
  }

  public Vector getConnessioni() {
  
    Vector listaCon = new Vector();
    for (int i = 0; i < cellule.length; i++)
      if (cellule[i].isAttiva())
        for (int j = 0; j < cellule[i].listaCon.size(); j++)
          listaCon.addElement(cellule[i].listaCon.elementAt(j));
    return listaCon;
  }
  
  public synchronized String toString() {
  
    String ret = "";
    for (int i = 0; i < cellule.length; i++)
      ret += cellule[i] + ", ";
    return ret;
  }

  public void resume() {

    for (int i = 0; i < cellule.length; i++)
      cellule[i].setFermo(false);
  }

  public void suspend() {

    for (int i = 0; i < cellule.length; i++)
      cellule[i].setFermo(true);
  }
}
