package trz.gaia;

import java.util.* ;
import java.awt.*;

public class SearchGraph extends Hashtable {

  String name ;

  public SearchGraph(String Name) {
    name = Name ;
  }

  // reset each SearhNode in the graph
  // clear expanded and tested flags, set depth=0
  void reset() {
    Enumeration enum = this.elements() ;
    while (enum.hasMoreElements()) {
      SearchNode nextNode = (SearchNode)enum.nextElement();
      nextNode.reset() ;
    }
  }

  // add node to Hashtable, using node label as key
  public void put(SearchNode node) {
    put(node.label, node) ;
  }

  //public void remove(String label) {
    
    //Provo cosi': non rimuovo mai nulla
    //L' unica cosa che cambia sono i link
  //}

  // do a depth first search on graph
  public SearchNode depthFirstSearch(SearchNode initialNode, Object goalState, Vector mancanti)
  {
    Vector queue = new Vector() ;
    queue.addElement(initialNode) ;
    initialNode.setTested(true) ;  // test each node once
  
    while (queue.size()> 0) {
      SearchNode testNode = (SearchNode)queue.firstElement() ;
      queue.removeElementAt(0) ;
      testNode.trace() ;           // display trace information

      //System.out.println("Rimuovo: " + testNode);
      mancanti.removeElement(testNode);
      
      if (testNode.state.equals(goalState)) 
        return testNode ; // found it
  
      if (!testNode.expanded) {
        testNode.expand(queue,SearchNode.FRONT);
      }
    }
    mancanti.removeElementAt(0);
    return null ;
  }
}

